net.sf.saxon.expr.instruct

## Class ResultDocument

- java.lang.Object
- - net.sf.saxon.expr.Expression
  - - net.sf.saxon.expr.instruct.Instruction
    - - net.sf.saxon.expr.instruct.ResultDocument

- All Implemented Interfaces:
    DivisibleInstruction, Serializable, SourceLocator, LocationProvider, SaxonLocator, TailCallReturner, ValidatingInstruction, InstructionInfo, Locator

      public class ResultDocument
      extends Instruction
      implements ValidatingInstruction, DivisibleInstruction

  The compiled form of an xsl:result-document element in the stylesheet.

  The xsl:result-document element takes an attribute href="filename". The filename will often contain parameters, e.g. {position()} to ensure that a different file is produced for each element instance.

  There is a further attribute "format" which determines the format of the output file, it identifies the name of an xsl:output element containing the output format details. In addition, individual serialization properties may be specified as attributes. These are attribute value templates, so they may need to be computed at run-time.
  See Also:
    Serialized Form

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected String` | `baseURI`
    `protected Expression` | `content`
    `protected Expression` | `dynamicOutputElement`
    `protected Expression` | `formatExpression`
    `protected Properties` | `globalProperties`
    `protected Expression` | `href`
    `protected Properties` | `localProperties`
    `protected NamespaceResolver` | `nsResolver`
    `protected boolean` | `resolveAgainstStaticBase`
    `protected IntHashMap<Expression>` | `serializationAttributes`
    `protected ParseOptions` | `validationOptions`

    - ### Fields inherited from class net.sf.saxon.expr.Expression

      `EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, EVENT_FEED_METHOD, INHERITED_CONTEXT, INSPECTION_CONTEXT, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, NAVIGATION_CONTEXT, NODE_VALUE_CONTEXT, PROCESS_METHOD, PUSH_SELECTION, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, W3C_CONSUMING, W3C_FREE_RANGING, W3C_GROUP_CONSUMING, W3C_MOTIONLESS, WATCH_METHOD`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ResultDocument(Properties globalProperties, Properties localProperties, Expression href, Expression formatExpression, String baseURI, int validationAction, SchemaType schemaType, IntHashMap<Expression> serializationAttributes, NamespaceResolver nsResolver)` Create a result-document instruction

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `checkAcceptableUri(XPathContext context, String uri)`
    `Expression` | `copy()` Copy an expression.
    `void` | `explain(ExpressionPresenter out)` Diagnostic print of expression structure.
    `Properties` | `gatherOutputProperties(XPathContext context)` Create a properties object that combines the serialization properties specified on the xsl:result-document itself with those specified in the referenced xsl:output declaration
    `Expression` | `getContentExpression()` Get the expression that constructs the content
    `ExpressionCompiler` | `getExpressionCompiler()` Return the bytecode compiler for the ResultDocument expression
    `Expression` | `getFormatExpression()`
    `Expression` | `getHrefExpression()` Get the expression that computes the href attribute
    `int` | `getInstructionNameCode()` Get the name of this instruction for diagnostic and tracing purposes (the string "xsl:result-document")
    `int` | `getIntrinsicDependencies()` Determine the intrinsic dependencies of an expression, that is, those which are not derived from the dependencies of its subexpressions.
    `ItemType` | `getItemType(TypeHierarchy th)` Get the item type of the items returned by evaluating this instruction
    `static Result` | `getResult(Expression href, String baseURI, XPathContext context, OutputURIResolver resolver, boolean resolveAgainstStaticBase)`
    `SchemaType` | `getSchemaType()` Get the schema type chosen for validation; null if not defined
    `String` | `getStaticBaseURI()` Get the static base URI of the expression
    `int` | `getStreamability(int syntacticContext, boolean allowExtensions, List<String> reasons)` Analyse the streamability of the instruction
    `ResultDocumentAdjunct` | `getStreamingAdjunct()` Get a class that supports streamed evaluation of this expression
    `int` | `getValidationAction()` Get the validation mode for this instruction
    `ParseOptions` | `getValidationOptions()` Get the validation options
    `boolean` | `isAsynchronous()` Ask if the instruction is to be asynchronous
    `boolean` | `isResolveAgainstStaticBase()`
    `Iterator<Expression>` | `iterateSubExpressions()` Get all the XPath expressions associated with this instruction (in XSLT terms, the expression present on attributes of the instruction, as distinct from the child instructions in a sequence construction)
    `Expression` | `optimize(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Perform optimisation of an expression and its subexpressions.
    `void` | `process(Expression content, XPathContext context)`
    `void` | `processInstruction(Expression content, XPathContext context)` Evaluation method designed for calling from compiled bytecode.
    `TailCall` | `processLeavingTail(XPathContext context)` ProcessLeavingTail: called to do the real work of this instruction.
    `void` | `processLeft(Stack<XPathContext> contextStack, Stack<Object> state)` In streaming mode, process the first half of the instruction (for example, to start a new document or element)
    `void` | `processRight(Stack<XPathContext> contextStack, Stack<Object> state)` In streaming mode, process the right half of the instruction (for example, to end a new document or element)
    `static void` | `processXslOutputElement(NodeInfo element, Properties props, XPathContext c)` Construct a set of output properties from an xsl:output element supplied at run-time
    `protected void` | `promoteInst(PromotionOffer offer)` Handle promotion offers, that is, non-local tree rewrites.
    `boolean` | `replaceSubExpression(Expression original, Expression replacement)` Replace one subexpression by a replacement subexpression
    `void` | `setAsynchronous(boolean async)`
    `void` | `setContentExpression(Expression content)` Set the expression that constructs the content
    `void` | `setDynamicOutputElement(Expression exp)` Set an expression that evaluates to a run-time xsl:output element, used in the saxon:result-document() extension function designed for use in XQuery
    `void` | `setSchemaType(SchemaType type)` Set the schema type to be used for validation
    `static void` | `setSerializationProperty(Properties details, String uri, String lname, String value, NamespaceResolver nsResolver, boolean prevalidated, Configuration config)` Validate a serialization property and add its value to a Properties collection
    `void` | `setUseStaticBaseUri(boolean staticBase)` Set whether the the instruction should resolve the href relative URI against the static base URI (rather than the dynamic base output URI)
    `void` | `setValidationAction(int mode, SchemaType schemaType)` Set the validation mode for the new document
    `Expression` | `simplify(ExpressionVisitor visitor)` Simplify an expression.
    `static void` | `traceDestination(XPathContext context, Result result)`
    `Expression` | `typeCheck(ExpressionVisitor visitor, ExpressionVisitor.ContextItemType contextItemType)` Perform type checking of an expression and its subexpressions.

    - ### Methods inherited from class net.sf.saxon.expr.instruct.Instruction

      `assembleParams, assembleTunnelParams, computeCardinality, computeSpecialProperties, createsNewNodes, dynamicError, evaluateAsString, evaluateItem, getConstructType, getExpressionName, getImplementationMethod, getInstructionName, getIteratorFromProcessMethod, getSourceLocator, isXSLT, iterate, process, promote`

    - ### Methods inherited from class net.sf.saxon.expr.Expression

      `addToPathMap, adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, dynamicError, effectiveBooleanValue, evaluatePendingUpdates, explain, getCardinality, getColumnNumber, getColumnNumber, getContainer, getDependencies, getEvaluationMethod, getExecutable, getHostLanguage, getIntegerBounds, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getSystemId, getSystemId, hasVariableBinding, implementsStaticTypeCheck, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, iterateEvents, iterateSubExpressionInfo, markTailFunctionCalls, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setFlattened, setLocationId, staticTypeCheck, suppressValidation, toPattern, toStreamingPattern, toString, typeError`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface javax.xml.transform.SourceLocator

      `getColumnNumber, getLineNumber, getPublicId, getSystemId`

- - ### Field Detail

    - #### href

          protected Expression href

    - #### formatExpression

          protected Expression formatExpression

    - #### content

          protected Expression content

    - #### globalProperties

          protected Properties globalProperties

    - #### localProperties

          protected Properties localProperties

    - #### baseURI

          protected String baseURI

    - #### validationOptions

          protected ParseOptions validationOptions

    - #### serializationAttributes

          protected IntHashMap<Expression> serializationAttributes

    - #### nsResolver

          protected NamespaceResolver nsResolver

    - #### dynamicOutputElement

          protected Expression dynamicOutputElement

    - #### resolveAgainstStaticBase

          protected boolean resolveAgainstStaticBase

  - ### Constructor Detail

    - #### ResultDocument

          public ResultDocument(Properties globalProperties,
                        Properties localProperties,
                        Expression href,
                        Expression formatExpression,
                        String baseURI,
                        int validationAction,
                        SchemaType schemaType,
                        IntHashMap<Expression> serializationAttributes,
                        NamespaceResolver nsResolver)

      Create a result-document instruction
      Parameters:
        `globalProperties` - properties defined on static xsl:output
        `localProperties` - non-AVT properties defined on result-document element
        `href` - href attribute of instruction
        `formatExpression` - format attribute of instruction
        `baseURI` - base URI of the instruction
        `validationAction` - for example `Validation.STRICT`
        `schemaType` - schema type against which output is to be validated
        `serializationAttributes` - computed local properties
        `nsResolver` - namespace resolver

  - ### Method Detail

    - #### setContentExpression

          public void setContentExpression(Expression content)

      Set the expression that constructs the content
      Parameters:
        `content` - the expression defining the content of the result document

    - #### getContentExpression

          public Expression getContentExpression()

      Get the expression that constructs the content
      Specified by:
        `getContentExpression` in interface `DivisibleInstruction`
      Returns:
        the content expression

    - #### setSchemaType

          public void setSchemaType(SchemaType type)

      Set the schema type to be used for validation
      Parameters:
        `type` - the type to be used for validation. (For a document constructor, this is the required type of the document element)

    - #### getSchemaType

          public SchemaType getSchemaType()

      Get the schema type chosen for validation; null if not defined
      Specified by:
        `getSchemaType` in interface `ValidatingInstruction`
      Returns:
        the type to be used for validation. (For a document constructor, this is the required type of the document element)

    - #### getHrefExpression

          public Expression getHrefExpression()

      Get the expression that computes the href attribute
      Returns:
        the href expression, or null if there is no href attribute

    - #### getStaticBaseURI

          public String getStaticBaseURI()

      Get the static base URI of the expression
      Returns:
        the static base URI

    - #### isResolveAgainstStaticBase

          public boolean isResolveAgainstStaticBase()

    - #### getValidationOptions

          public ParseOptions getValidationOptions()

      Get the validation options
      Returns:
        the validation options for the content of the constructed node. May be null if no validation was requested.

    - #### setValidationAction

          public void setValidationAction(int mode,
                                 SchemaType schemaType)

      Set the validation mode for the new document
      Parameters:
        `mode` - the validation mode, for example `Validation.STRICT`
        `schemaType` - the required type (for validation by type). Null if not validating by type

    - #### getValidationAction

          public int getValidationAction()

      Get the validation mode for this instruction
      Specified by:
        `getValidationAction` in interface `ValidatingInstruction`
      Returns:
        the validation mode, for example `Validation.STRICT` or `Validation.PRESERVE`

    - #### getFormatExpression

          public Expression getFormatExpression()

    - #### setDynamicOutputElement

          public void setDynamicOutputElement(Expression exp)

      Set an expression that evaluates to a run-time xsl:output element, used in the saxon:result-document() extension function designed for use in XQuery
      Parameters:
        `exp` - the expression whose result should be an xsl:output element

    - #### setUseStaticBaseUri

          public void setUseStaticBaseUri(boolean staticBase)

      Set whether the the instruction should resolve the href relative URI against the static base URI (rather than the dynamic base output URI)
      Parameters:
        `staticBase` - set to true by fn:put(), to resolve against the static base URI of the query. Default is false, which causes resolution against the base output URI obtained dynamically from the Controller

    - #### setAsynchronous

          public void setAsynchronous(boolean async)

    - #### isAsynchronous

          public boolean isAsynchronous()

      Ask if the instruction is to be asynchronous
      Returns:
        true unless saxon:asynchronous="no" was specified (regardless of other options that might suppress asychronous operation)

    - #### simplify

          public Expression simplify(ExpressionVisitor visitor)
                              throws XPathException

      Simplify an expression. This performs any static optimization (by rewriting the expression as a different expression). The default implementation does nothing.
      Specified by:
        `simplify` in class `Instruction`
      Parameters:
        `visitor` - an expression visitor
      Returns:
        the simplified expression
      Throws:
        `XPathException` - if an error is discovered during expression rewriting

    - #### typeCheck

          public Expression typeCheck(ExpressionVisitor visitor,
                             ExpressionVisitor.ContextItemType contextItemType)
                               throws XPathException

      Description copied from class: `Expression`
      Perform type checking of an expression and its subexpressions. This is the second phase of static optimization.

      This checks statically that the operands of the expression have the correct type; if necessary it generates code to do run-time type checking or type conversion. A static type error is reported only if execution cannot possibly succeed, that is, if a run-time type error is inevitable. The call may return a modified form of the expression.

      This method is called after all references to functions and variables have been resolved to the declaration of the function or variable. However, the types of such functions and variables may not be accurately known if they have not been explicitly declared.

      If the implementation returns a value other than "this", then it is required to ensure that the location information in the returned expression have been set up correctly. It should not rely on the caller to do this, although for historical reasons many callers do so.

      Overrides:
        `typeCheck` in class `Expression`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        the original expression, rewritten to perform necessary run-time type checks, and to perform other type-related optimizations
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### optimize

          public Expression optimize(ExpressionVisitor visitor,
                            ExpressionVisitor.ContextItemType contextItemType)
                              throws XPathException

      Description copied from class: `Expression`
      Perform optimisation of an expression and its subexpressions. This is the third and final phase of static optimization.

      This method is called after all references to functions and variables have been resolved to the declaration of the function or variable, and after all type checking has been done.

      Overrides:
        `optimize` in class `Expression`
      Parameters:
        `visitor` - an expression visitor
        `contextItemType` - the static type of "." at the point where this expression is invoked. The parameter is set to null if it is known statically that the context item will be undefined. If the type of the context item is not known statically, the argument is set to `Type.ITEM_TYPE`
      Returns:
        the original expression, rewritten if appropriate to optimize execution
      Throws:
        `XPathException` - if an error is discovered during this phase (typically a type error)

    - #### getIntrinsicDependencies

          public int getIntrinsicDependencies()

      Description copied from class: `Expression`
      Determine the intrinsic dependencies of an expression, that is, those which are not derived from the dependencies of its subexpressions. For example, position() has an intrinsic dependency on the context position, while (position()+1) does not. The default implementation of the method returns 0, indicating "no dependencies".
      Overrides:
        `getIntrinsicDependencies` in class `Expression`
      Returns:
        a set of bit-significant flags identifying the "intrinsic" dependencies. The flags are documented in class net.sf.saxon.value.StaticProperty

    - #### copy

          public Expression copy()

      Copy an expression. This makes a deep copy.
      Specified by:
        `copy` in class `Expression`
      Returns:
        the copy of the original expression

    - #### promoteInst

          protected void promoteInst(PromotionOffer offer)
                              throws XPathException

      Handle promotion offers, that is, non-local tree rewrites.
      Overrides:
        `promoteInst` in class `Instruction`
      Parameters:
        `offer` - The type of rewrite being offered
      Throws:
        `XPathException`

    - #### getInstructionNameCode

          public int getInstructionNameCode()

      Get the name of this instruction for diagnostic and tracing purposes (the string "xsl:result-document")
      Overrides:
        `getInstructionNameCode` in class `Instruction`
      Returns:
        a code identifying the instruction: typically but not always the fingerprint of a name in the XSLT namespace

    - #### getItemType

          public ItemType getItemType(TypeHierarchy th)

      Get the item type of the items returned by evaluating this instruction
      Overrides:
        `getItemType` in class `Instruction`
      Parameters:
        `th` - the type hierarchy cache
      Returns:
        the static item type of the instruction. This is empty: the result-document instruction returns nothing.

    - #### iterateSubExpressions

          public Iterator<Expression> iterateSubExpressions()

      Get all the XPath expressions associated with this instruction (in XSLT terms, the expression present on attributes of the instruction, as distinct from the child instructions in a sequence construction)
      Overrides:
        `iterateSubExpressions` in class `Expression`
      Returns:
        an iterator containing the sub-expressions of this expression

    - #### replaceSubExpression

          public boolean replaceSubExpression(Expression original,
                                     Expression replacement)

      Replace one subexpression by a replacement subexpression
      Overrides:
        `replaceSubExpression` in class `Expression`
      Parameters:
        `original` - the original subexpression
        `replacement` - the replacement subexpression
      Returns:
        true if the original subexpression is found

    - #### processLeavingTail

          public TailCall processLeavingTail(XPathContext context)
                                      throws XPathException

      Description copied from class: `Instruction`
      ProcessLeavingTail: called to do the real work of this instruction. This method must be implemented in each subclass. The results of the instruction are written to the current Receiver, which can be obtained via the Controller.
      Specified by:
        `processLeavingTail` in interface `TailCallReturner`
      Specified by:
        `processLeavingTail` in class `Instruction`
      Parameters:
        `context` - The dynamic context of the transformation, giving access to the current node, the current variables, etc.
      Returns:
        null if the instruction has completed execution; or a TailCall indicating a function call or template call that is delegated to the caller, to be made after the stack has been unwound so as to save stack space.
      Throws:
        `XPathException` - if a dynamic error occurs during the evaluation of the instruction

    - #### process

          public void process(Expression content,
                     XPathContext context)
                       throws XPathException

      Throws:
        `XPathException`

    - #### processInstruction

          public void processInstruction(Expression content,
                                XPathContext context)
                                  throws XPathException

      Evaluation method designed for calling from compiled bytecode.
      Parameters:
        `content` - The content expression. When called from bytecode, this will be the compiled version of the interpreted content expression
        `context` - dynamic evaluation context
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### getResult

          public static Result getResult(Expression href,
                         String baseURI,
                         XPathContext context,
                         OutputURIResolver resolver,
                         boolean resolveAgainstStaticBase)
                                  throws XPathException

      Throws:
        `XPathException`

    - #### traceDestination

          public static void traceDestination(XPathContext context,
                              Result result)

    - #### checkAcceptableUri

          public static void checkAcceptableUri(XPathContext context,
                                String uri)
                                         throws XPathException

      Throws:
        `XPathException`

    - #### gatherOutputProperties

          public Properties gatherOutputProperties(XPathContext context)
                                            throws XPathException

      Create a properties object that combines the serialization properties specified on the xsl:result-document itself with those specified in the referenced xsl:output declaration
      Parameters:
        `context` - The XPath evaluation context
      Returns:
        the assembled properties
      Throws:
        `XPathException` - if invalid properties are found

    - #### setSerializationProperty

          public static void setSerializationProperty(Properties details,
                                      String uri,
                                      String lname,
                                      String value,
                                      NamespaceResolver nsResolver,
                                      boolean prevalidated,
                                      Configuration config)
                                               throws XPathException

      Validate a serialization property and add its value to a Properties collection
      Parameters:
        `details` - the properties to be updated
        `uri` - the uri of the property name
        `lname` - the local part of the property name
        `value` - the value of the serialization property. In the case of QName-valued values, this will use lexical QNames if prevalidated is false and a NamespaceResolver is supplied; otherwise they will use Clark-format names
        `nsResolver` - resolver for lexical QNames; not needed if prevalidated, or if QNames are supplied in Clark format
        `prevalidated` - true if values are already known to be valid and lexical QNames have been expanded into Clark notation
        `config` - the Saxon configuration
      Throws:
        `XPathException` - if any serialization property has an invalid value

    - #### explain

          public void explain(ExpressionPresenter out)

      Diagnostic print of expression structure. The abstract expression tree is written to the supplied output destination.
      Specified by:
        `explain` in class `Expression`
      Parameters:
        `out` - the expression presenter used to display the structure

    - #### processXslOutputElement

          public static void processXslOutputElement(NodeInfo element,
                                     Properties props,
                                     XPathContext c)
                                              throws XPathException

      Construct a set of output properties from an xsl:output element supplied at run-time
      Parameters:
        `element` - an xsl:output element
        `props` - Properties object to which will be added the values of those serialization properties that were specified
        `c` - the XPath dynamic context
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### getExpressionCompiler

          public ExpressionCompiler getExpressionCompiler()

      Return the bytecode compiler for the ResultDocument expression
      Overrides:
        `getExpressionCompiler` in class `Expression`
      Returns:
        the relevant ExpressionCompiler

    - #### getStreamability

          public int getStreamability(int syntacticContext,
                             boolean allowExtensions,
                             List<String> reasons)

      Analyse the streamability of the instruction
      Overrides:
        `getStreamability` in class `Expression`
      Parameters:
        `syntacticContext` - one of the values `Expression.NAVIGATION_CONTEXT`, `Expression.NODE_VALUE_CONTEXT`, `Expression.INHERITED_CONTEXT`, `Expression.INSPECTION_CONTEXT`
        `allowExtensions` - if false, the definition of "guaranteed streamability" in the W3C specification is used. If true, Saxon extensions are permitted, which make some
        `reasons` - the caller may supply a list, in which case the implementation may add to this list a message explaining why the construct is not streamable, suitable for inclusion in an error message.
      Returns:
        the "sweep" of the instruction

    - #### getStreamingAdjunct

          public ResultDocumentAdjunct getStreamingAdjunct()

      Get a class that supports streamed evaluation of this expression
      Overrides:
        `getStreamingAdjunct` in class `Expression`
      Returns:
        the relevant StreamingAdjunct, or null if none is available

    - #### processLeft

          public void processLeft(Stack<XPathContext> contextStack,
                         Stack<Object> state)
                           throws XPathException

      In streaming mode, process the first half of the instruction (for example, to start a new document or element)
      Specified by:
        `processLeft` in interface `DivisibleInstruction`
      Parameters:
        `contextStack` - Stack of XPathContext objects. The instruction should use the one at the top of the stack. Some instructions (such as xsl:result-document) create a new context object and add it to the stack, removing it in the corresponding processRight() action.
        `state` - a stack on which the instruction can save state information during the call on processLeft()
      Throws:
        `XPathException` - if a dynamic error occurs

    - #### processRight

          public void processRight(Stack<XPathContext> contextStack,
                          Stack<Object> state)
                            throws XPathException

      In streaming mode, process the right half of the instruction (for example, to end a new document or element)
      Specified by:
        `processRight` in interface `DivisibleInstruction`
      Parameters:
        `contextStack` - the stack of dynamic context objects
        `state` - a stack on which the instruction can save state information during the call on processLeft()
      Throws:
        `XPathException` - if a dynamic error occurs

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.